"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.createForm=createForm;function ownKeys(a,b){var c=Object.keys(a);if(Object.getOwnPropertySymbols){var d=Object.getOwnPropertySymbols(a);b&&(d=d.filter(function(b){return Object.getOwnPropertyDescriptor(a,b).enumerable})),c.push.apply(c,d)}return c}function _objectSpread(a){for(var b,c=1;c<arguments.length;c++)b=null==arguments[c]?{}:arguments[c],c%2?ownKeys(Object(b),!0).forEach(function(c){_defineProperty(a,c,b[c])}):Object.getOwnPropertyDescriptors?Object.defineProperties(a,Object.getOwnPropertyDescriptors(b)):ownKeys(Object(b)).forEach(function(c){Object.defineProperty(a,c,Object.getOwnPropertyDescriptor(b,c))});return a}function _defineProperty(a,b,c){return b in a?Object.defineProperty(a,b,{value:c,enumerable:!0,configurable:!0,writable:!0}):a[b]=c,a}/**
 * Create a Vue form
 *
 * NOTE: Form tracks whether any values have changed via "flags.changed",
 *         which is more reliable than the VeeValidate flags.
 *
 * @param  {string} name   - Form name ('data' key)
 * @param  {Object} fields - Form fields and initial values
 * @return {Object}        - Vue form
 */function createForm(a,b){/**
   * Determine whether any form fields have changed
   * @return {boolean} - Whether any fields have changed
   */var c=_defineProperty({},a,{// Clone the fields to set as initial values (for reset)
_initial:_objectSpread({},b),flags:{// NOTE: Declared even though overridden so that it is tracked by object
changed:!1,get disabled(){return this.loading||this.submitting},loading:!1,submitting:!1},fields:b,/**
       * Get the form values
       * @return {Object} - Form values
       */getValues:function getValues(){return this.fields},/**
       * Set a form flag
       * @param {string}  flag  - Form flag name
       * @param {boolean} value - Form flag value
       */_setFlag:function _setFlag(a,b){this.flags[a]=b},/**
       * Set whether the form is loading
       * @param {boolean} isLoading - Whether form is loading
       */setLoading:function setLoading(a){this._setFlag("loading",a)},/**
       * Set whether the form is submitting
       * @param {boolean} isSubmitting - Whether form is submitting
       */setSubmitting:function setSubmitting(a){this._setFlag("submitting",a)},/**
       * Set the form values
       * @param {Object}  values     - New form values
       * @param {boolean} setInitial - Whether initial values should be updated
       */setValues:function setValues(a){var b=this,c=!(1<arguments.length&&void 0!==arguments[1])||arguments[1];Object.keys(a).forEach(function(c){var d=a[c];b.fields[c]=d}),c&&Object.keys(a).forEach(function(c){var d=a[c];b._initial[c]=d})},/**
       * Reset the form to its initial values
       */reset:function reset(){var a=this;Object.keys(this._initial).forEach(function(b){var c=a._initial[b];a.fields[b]=c})}}),d=function(){var a=this;return Object.keys(this.fields).some(function(b){var c=a.fields[b],d=a._initial[b];return c!==d})}.bind(c[a]);return Object.defineProperty(c[a].flags,"changed",{get:d}),c}/* eslint no-underscore-dangle: off */